library evo;
/**
# Simple Simulation of Evolution
Evolution Strategies, sometimes also
referred to as Evolutionary Strategies, and Evolutionary
Programming are search paradigms
inspired by the principles of biological evolution.
They belong to the family of evolutionary
algorithms that address optimization problems
by implementing a repeated process of
(small) stochastic variations followed by selection:
in each generation (or iteration), new off-
spring (or candidate solutions) are generated
from their parents (candidate solutions already
visited), their fitness is evaluated, and the better
offspring are selected to become the parents for
the next generation.
Evolution strategies most commonly address
the problem of continuous black-box optimization.
The search space is the continuous domain,
solutions in search space are n-dimensional
vectors, and an objective or fitness function is
to be minimized. We make no specific assumptions
on that function, other than that it can be evaluated
for each solution, and refer to this search problem
as black-box optimization. The objective
is, loosely speaking, to generate solutions
with small function-values while using a small
number of function-evaluations.
*/


import "./src/property.dart";
import "./src/chromosome.dart";
import "./src/utils.dart";
import "dart:collection" as c;

void main() {
  var i = new Chromosome.create(23, 3, 3);
  print(i);
  i.mutateByProperty();
  print(i);
  i.mutateByChromosome();
  print(i);
  var p = new Property.simpleCreate();
  var l = new List(2);
  l.fillRange(0, 2, 3);
  print(l);
}
