import "dart:math" as m;
import "./property.dart";
import "./utils.dart" as u;

class Chromosome {
  List<Property> vector;
  List<num> strategy;
  num fitness = 0;

  Chromosome(List<Property> this.vector) {}

  factory Chromosome.create(num center, num strategy, num size) {
    // Der Suchraum sollte zu Iteration bei der Generierung dienen.
    List<Property> vector = new List<Property>();
    // for size of search space
    for (var i = 0; i < size; i++) {
      var p = new Property(center, strategy);
      vector.add(p);
      print("create ${p}");
    }
    return new Chromosome(vector);
  }
  factory Chromosome.normalcreate(num size) {
    List<Property> vector = new List<Property>();
    for (var i = 0; i++; i < size) {
      var p = new Property(0, 1);
      vector.add(p);
    }
    return new Chromosome(vector);
  }

// List<num> this.strategy, List<MinMax>  this.search_space

  List<num> objective_function(List<Property> vector) {
    return vector.fold(0.0, (sum, x) => sum + (m.pow(x.value, 2.0)));
  }

  void mutateByChromosome() {
    List<Property> v = vector.map(
        (Property x) => new Property(((u.rdouble()) + x.value), x.deviation));

    this.vector = v;
  }

  void mutateByProperty() {
    vector.forEach((Property x) => x.mutate());
  }

  String toString() {
    return ("Chromosome " +
        "Fitness: " +
        this.fitness.toString() +
        " Vector: " +
        this.vector.toString());
  }
}
